//
//
// mount [-fnrsvw] [-t vfstype] [-o options] device dir

static gchar **mount_option_keys = NULL;
static  GroupOptions mount_options[]={
//linux options:
    {
	.sensitive = 1, .flag = "-r", .id = NULL, 
        .text = N_(" Mount file system readonly."), 
	.entry = NULL
    },
    {
	.sensitive = 1, .flag = "-v", .id = NULL, 
        .text = N_("Be verbose."), 
	.entry = NULL
    },
    {
	.sensitive = 1, .flag = "-V", .id = NULL, 
        .text = N_("Print version."), 
	.entry = NULL
    },
    {
	.sensitive = 2, .flag = "-w", .id = NULL, 
        .text = N_("Mount file system read-write."), 
	.entry = NULL
    },
#ifdef THIS_IS_LINUX
    {
	.sensitive = 1, .flag = "-f", .id = NULL, 
        .text = N_("Fake mount."), 
        .tip = N_("Don't actually call the mount system call."), 
	.entry = NULL
    },
    {
	.sensitive = 1, .flag = "-n", .id = NULL, 
        .text = N_("Do  not  update  /etc/mtab."), 
	.tip = 
N_("By default, an entry is created in/etc/mtab for every mounted file system.\n Use this option to skip making an entry."),
	.entry = NULL
    },
    {
	.sensitive = 1, .flag = "-s", .id = NULL, 
	.text = N_("Tolerate sloppy options."),
        .tip = N_("Tolerate sloppy mount options rather than fail."), 
	.entry = NULL
    },
#endif
    {
	.sensitive = 1, .flag = "-h", .id = NULL, 
        .text = N_("Print help message."), 
	.entry = NULL
    },
    
    {.sensitive = 1, NULL, NULL, NULL, .entry = NULL}
};


